| Linduino 1.3.0 Linear Technology Arduino-Compatible Demonstration Board

Functions | Variables
LTC6946.cpp File Reference
RF, Silicon Oscillators, PLL Synthesizers, and VCOs » LTC6946: Ultralow Noise and Spurious 0.37GHz to 6.39GHz IntegerN Synthesizer with Integrated VCO

Library for LTC6946: Ultralow Noise and Spurious 0.37GHz to 6.39GHz IntegerN Synthesizer with Integrated VCO. More...

## Detailed Description

Library for LTC6946: Ultralow Noise and Spurious 0.37GHz to 6.39GHz IntegerN Synthesizer with Integrated VCO.

Definition in file LTC6946.cpp.

Go to the source code of this file.

## Functions
uint8_t | LTC6946_read (uint8_t cs, int8_t address)
| LTC6946 Read Single Address reads 8 bit Data field to LTC6946. More...
long | LTC6946_read_field (uint8_t cs, uint8_t address, uint8_t MSB_loc, uint8_t numbits)
| LTC6946 Read Single Field For SPI FIELDS located in 1 or multiple address locations reads specific address locations identifies and returns specific field in question can handle SPI fields in multiple addresses, if MSB bit is in the lower number address. More...
long | get_LTC6946_SPI_FIELD (uint8_t cs, uint8_t f)
| Gets the LTC6946 SPI field value calls function LTC6946_read_field, which reads specific address locations identifies and returns specific field in question can handle SPI fields in multiple addresses, if MSB bit is in the lower number address. More...
void | LTC6946_write (uint8_t cs, uint8_t address, uint8_t Data)
| LTC6946 Write Single Address writes 8 bit Data field to LTC6946. More...
uint8_t | LTC6946_write_field (uint8_t cs, long field_data, uint8_t address, uint8_t MSB_loc, uint8_t numbits)
| LTC6946 Write Single Field For SPI FIELDS in 1 or multiple address locations reads specific address/field location then writes to specific field can handle SPI fields in multiple addresses, if MSB bit is in the lower number address. More...
uint8_t | get_LTC6946_REGSIZE ()
| returns # of addresses in parts register map (array size) More...
uint8_t | get_LTC6946_SPI_FIELD_NUMBITS (uint8_t f)
| returns the number of bits for a given field name in the SPI map More...
uint8_t | get_LTC6946_SPI_FIELD_RW (uint8_t f)
| returns if the given field name is (0)read/write or (1)read_only field More...
void | set_LTC6946_SPI_FIELD (uint8_t cs, uint8_t f, long field_data)
| Sets the LTC6946 SPI field value calls function LTC6946_read_field, which reads specific address/field location then writes to specific field can handle SPI fields in multiple addresses, if MSB bit is in the lower number address. More...
void | set_LTC6946_ALLREGS (uint8_t cs, uint8_t reg01, uint8_t reg02, uint8_t reg03, uint8_t reg04, uint8_t reg05, uint8_t reg06, uint8_t reg07, uint8_t reg08, uint8_t reg09, uint8_t reg0A)
| Writes values to ALL LTC6946 RW address. More...
void | LTC6946_init ()
| Initializes the SPI MAP arrays The values set in initialization are used all the LTC6946 SPI/WRITE and read functions (set_LTC6946_SPI_FIELD, get_LTC6946_SPI_FIELD, LTC6946_read, LTC6946_write, etc, etc) More...
void | set_LTC6946_global_fref (unsigned long fref_MHz, unsigned long fref_Hz)
| sets globals LTC6946_Fref_MHz and LTC6946_Fref_Hz More...
void | set_LTC6946_global_frf (unsigned long frf_MHz, unsigned long frf_Hz)
| sets globals LTC6946_Frf_MHz and LTC6946_Frf_Hz More...
unsigned long | get_LTC6946_global_fref_MHz ()
| returns global LTC6946_Fref_MHz More...
unsigned long | get_LTC6946_global_fref_Hz ()
| returns global LTC6946_Fref_Hz More...
unsigned long | get_LTC6946_global_frf_MHz ()
| returns global LTC6946_Frf_MHz More...
unsigned long | get_LTC6946_global_frf_Hz ()
| returns global LTC6946_Frf_Hz More...
unsigned long | LTC6946_calc_odiv (char part_version[], unsigned long frf[2])
| calculates the output divider setting based on the frf and version of LTC6946 More...
void | LTC6946_set_frf (char part_version[])
| FUNCTION: LTC6946_set_frf Calculates the integer (N), fractional (NUM) and output divider (OD) SPI values using self created 64bit math functions. More...
void | prt (unsigned long an[])
| Prints HEX representation of 64 bit an. More...
void | init64 (unsigned long an[], unsigned long bigPart, unsigned long littlePart)
| Creates a equivalent 64 bit number from 2 32 bit numbers. More...
void | HZto64 (unsigned long an[], unsigned long MHzPart, unsigned long HzPart)
| create a 64 bit Hz number from 32 bit xxxx MHz number and 32 bit yyy yyy Hz number. More...
void | shl64 (unsigned long an[])
| Single Bit shift left of equivalent 64 bit number (an[] = an[]<<1) More...
void | shr64 (unsigned long an[])
| Single Bit shift right of equivalent 64 bit number (an[] = an[]<<1) More...
void | shl64by (unsigned long an[], uint8_t shiftnum)
| Multi Bit shift left of equivalent 64 bit number (an[] = an[]<<shiftnum) More...
void | shr64by (unsigned long an[], uint8_t shiftnum)
| Multi Bit shift right of equivalent 64 bit number (an[] = an[]>>shiftnum) More...
void | add64 (unsigned long an[], unsigned long ann[])
| 64 bit Add ann to an (an[] = an[] + ann[]) More...
void | sub64 (unsigned long an[], unsigned long ann[])
| 64 bit Subtract ann from an (an[] = an[] - ann[]) More...
boolean | eq64 (unsigned long an[], unsigned long ann[])
| 64 bit, if an == ann, then true More...
boolean | lt64 (unsigned long an[], unsigned long ann[])
| 64 bit, if an < ann, then true More...
void | div64 (unsigned long num[], unsigned long den[])
| 64 bit Divide, num=num/div More...
void | mul64 (unsigned long an[], unsigned long ann[])
| 64 bit multiply, an=an*ann More...

## Variables
uint8_t | LTC6946_reg [LTC6946_NUM_REGADDR]
| number of LTC6946 spi addresses More...
uint8_t | LTC6946_spi_map [(LTC6946_NUM_REGFIELD+1)][4]
| LTC6946 spi map, stores MSB address location, MSB bit location, field length in bits, and R or RW capability. More...
unsigned long | LTC6946_Fref_MHz = 100
| Default Fref frequency - MHz portion (xxx); Fref = xxx, yyy,yyy. More...
unsigned long | LTC6946_Fref_Hz = 0
| Default Fref frequency - Hz portion (yyy,yyy); Fref = x,xxx, yyy,yyy. More...
unsigned long | LTC6946_Frf_MHz = 900
| Default Frf frequency - MHz portion (xxxx); Frf = x,xxx, yyy,yyy. More...
unsigned long | LTC6946_Frf_Hz = 0
| Default Frf frequency - Hz portion (yyy,yyy); Frf = x,xxx, yyy,yyy. More...
unsigned long | zero64 [] = {0,0}
| for 64bit math functions More...

## Function Documentation

## ◆ add64()

void add64 | ( | unsigned long | an[],
|  | unsigned long | ann[]
| ) |  |

64 bit Add ann to an (an[] = an[] + ann[])

Returns
  void

Parameters

  an | 64 bit number, in 1x2 32bit array
  ann | 64 bit number, in 1x2 32bit array

Definition at line 881 of file LTC6946.cpp.

## ◆ div64()

void div64 | ( | unsigned long | num[],
|  | unsigned long | den[]
| ) |  |

64 bit Divide, num=num/div

Returns
  void

Parameters

  num | numerator: 64 bit number, in 1x2 32bit array
  den | denominator: 64 bit number, in 1x2 32bit array

Definition at line 930 of file LTC6946.cpp.

## ◆ eq64()

boolean eq64 | ( | unsigned long | an[],
|  | unsigned long | ann[]
| ) |  |

64 bit, if an == ann, then true

Returns
  true, if an==ann; false, if an<>ann

Parameters

  an | 64 bit number, in 1x2 32bit array
  ann | 64 bit number, in 1x2 32bit array

Definition at line 909 of file LTC6946.cpp.

## ◆ get_LTC6946_global_fref_Hz()

unsigned long get_LTC6946_global_fref_Hz | ( |  | ) |

returns global LTC6946_Fref_Hz

Returns
  LTC6946_Fref_Hz

Definition at line 489 of file LTC6946.cpp.

## ◆ get_LTC6946_global_fref_MHz()

unsigned long get_LTC6946_global_fref_MHz | ( |  | ) |

returns global LTC6946_Fref_MHz

Returns
  LTC6946_Fref_MHz

Definition at line 484 of file LTC6946.cpp.

## ◆ get_LTC6946_global_frf_Hz()

unsigned long get_LTC6946_global_frf_Hz | ( |  | ) |

returns global LTC6946_Frf_Hz

Returns
  LTC6946_Frf_Hz

Definition at line 499 of file LTC6946.cpp.

## ◆ get_LTC6946_global_frf_MHz()

unsigned long get_LTC6946_global_frf_MHz | ( |  | ) |

returns global LTC6946_Frf_MHz

Returns
  LTC6946_Frf_MHz

Definition at line 494 of file LTC6946.cpp.

## ◆ get_LTC6946_REGSIZE()

uint8_t get_LTC6946_REGSIZE | ( |  | ) |

returns # of addresses in parts register map (array size)

Returns
  # of addresses in parts register map

Definition at line 232 of file LTC6946.cpp.

## ◆ get_LTC6946_SPI_FIELD()

long get_LTC6946_SPI_FIELD | ( | uint8_t | cs,
|  | uint8_t | f
| ) |  |

Gets the LTC6946 SPI field value calls function LTC6946_read_field, which reads specific address locations identifies and returns specific field in question can handle SPI fields in multiple addresses, if MSB bit is in the lower number address.

Returns
  data that was read from field

Parameters

  cs | Chip Select Pin
  f | SPI field number

Definition at line 154 of file LTC6946.cpp.

## ◆ get_LTC6946_SPI_FIELD_NUMBITS()

uint8_t get_LTC6946_SPI_FIELD_NUMBITS | ( | uint8_t | f | ) |

returns the number of bits for a given field name in the SPI map

Returns
  the number of bits for a given field name in the SPI map

Parameters

  f | SPI field number

Definition at line 242 of file LTC6946.cpp.

## ◆ get_LTC6946_SPI_FIELD_RW()

uint8_t get_LTC6946_SPI_FIELD_RW | ( | uint8_t | f | ) |

returns if the given field name is (0)read/write or (1)read_only field

Returns
  if the given field is a (0)read/write or (1)read_only field

Parameters

  f | SPI field number

Definition at line 252 of file LTC6946.cpp.

## ◆ HZto64()

void HZto64 | ( | unsigned long | an[],
|  | unsigned long | MHzPart,
|  | unsigned long | HzPart
| ) |  |

create a 64 bit Hz number from 32 bit xxxx MHz number and 32 bit yyy yyy Hz number.

A) if an < 2^32 bits:

- an(upper 32b) = 0;
- an(lower 32b) = MHzPart(32b)*1MHz + HzPart (32b)

B) if an > 2^32 bits (4,294,967,296):

- an(upper 32b) = 1
- an(lower 32b) = ((MHzPart-4294)*1MHz+HzPart)-967296
  Returns
    void

Parameters

  an | 64 bit number, 1x2 32 bit array
  MHzPart | integer in MHZ
  HzPart | integer in Hz

Definition at line 800 of file LTC6946.cpp.

## ◆ init64()

void init64 | ( | unsigned long | an[],
|  | unsigned long | bigPart,
|  | unsigned long | littlePart
| ) |  |

Creates a equivalent 64 bit number from 2 32 bit numbers.

- an[0]=bigPart upper 32 bits
- an[1]=littlePart lower 32 bits
  Returns
    void

Parameters

  an | 64 bit number, 1x2 32 bit array
  bigPart | upper 32 bits
  littlePart | lower 32 bits

Definition at line 783 of file LTC6946.cpp.

## ◆ lt64()

boolean lt64 | ( | unsigned long | an[],
|  | unsigned long | ann[]
| ) |  |

64 bit, if an < ann, then true

Returns
  true, if an<ann; false, if an=>ann

Parameters

  an | 64 bit number, in 1x2 32bit array
  ann | 64 bit number, in 1x2 32bit array

Definition at line 919 of file LTC6946.cpp.

## ◆ LTC6946_calc_odiv()

unsigned long LTC6946_calc_odiv | ( | char | part_version[],
|  | unsigned long | frf[2]
| ) |  |

calculates the output divider setting based on the frf and version of LTC6946

Returns
  odiv = 1-6 divider setting for valid frequency, or 999 for invalid frequency

Parameters

  part_version | LTC6946 part number LTC6946-x
  frf | output frequency

Definition at line 510 of file LTC6946.cpp.

## ◆ LTC6946_init()

void LTC6946_init | ( |  | ) |

Initializes the SPI MAP arrays The values set in initialization are used all the LTC6946 SPI/WRITE and read functions (set_LTC6946_SPI_FIELD, get_LTC6946_SPI_FIELD, LTC6946_read, LTC6946_write, etc, etc)

Returns
  void

Definition at line 299 of file LTC6946.cpp.

## ◆ LTC6946_read()

uint8_t LTC6946_read | ( | uint8_t | cs,
|  | int8_t | address
| ) |  |

LTC6946 Read Single Address reads 8 bit Data field to LTC6946.

has to shift data by one bit to account for RW bit

Returns
  data that was read from address

Parameters

  cs | Chip Select Pin
  address | Register address for the LTC6946.

Definition at line 98 of file LTC6946.cpp.

## ◆ LTC6946_read_field()

long LTC6946_read_field | ( | uint8_t | cs,
|  | uint8_t | address,
|  | uint8_t | MSB_loc,
|  | uint8_t | numbits
| ) |  |

LTC6946 Read Single Field For SPI FIELDS located in 1 or multiple address locations reads specific address locations identifies and returns specific field in question can handle SPI fields in multiple addresses, if MSB bit is in the lower number address.

Returns
  data that was read from field

Parameters

  cs | Chip Select Pin
  address | Register address for the LTC6946.
  MSB_loc | MSB bit location of field
  numbits | length of field (i.e. number of bits in field)

Definition at line 118 of file LTC6946.cpp.

## ◆ LTC6946_set_frf()

void LTC6946_set_frf | ( | char | part_version[] | ) |

FUNCTION: LTC6946_set_frf Calculates the integer (N), fractional (NUM) and output divider (OD) SPI values using self created 64bit math functions.

Datasheet equations:

- fvco = fpfd*(N + F)
- frf = fvco/O

- fpfd = fref/R

  can be modified to the following equations:

  - N = (int) (fvco/fpfd) = (int) frf*O*R/fref

  where:

  - N = ndiv, O= odiv in the code below

  Linduino One (Arduino Uno) is limited to 32 bit floats/double/long. 32 bit math functions will create rounding errors with the above equations, that can result in frequency errors. Therefore, the following code uses self created 64bit functions for 64bit integer math.

  - frf (33 bits) LTC6946-4 max frf/fvco = 6.4GHZ, which is 33 bit number (2^33 = 8.59G)
  - fref (23 bits) LTC6946 min fref = 10MHz, which is a 23 bit number (2^23 = 8.3M)
  - O (3 bits)
  - R (10 bits)

  step 1: create 64 bit frf and fref numbers

  step 2: calculate O (output divider)

  step 3: get current R-divider setting

  step 4: calculate frf*O*R max bit count/resolution: 33b+3b+10b= 46b

  step 5: calculate N(16b), using value from step 1

  - N = (int) frf*O*R/fref
  - max bit count/resolution: 46b-23b = 23b
    Returns
      void

Parameters

  part_version | LTC6946 part number LTC6946-x

Definition at line 609 of file LTC6946.cpp.

## ◆ LTC6946_write()

void LTC6946_write | ( | uint8_t | cs,
|  | uint8_t | address,
|  | uint8_t | Data
| ) |  |

LTC6946 Write Single Address writes 8 bit Data field to LTC6946.

has to shift data by one bit to account for RW bit

Returns
  void

Parameters

  cs | Chip Select Pin
  address | Register address for the LTC6946.
  Data | 8-bit data to be written to register

Definition at line 165 of file LTC6946.cpp.

## ◆ LTC6946_write_field()

uint8_t LTC6946_write_field | ( | uint8_t | cs,
|  | long | field_data,
|  | uint8_t | address,
|  | uint8_t | MSB_loc,
|  | uint8_t | numbits
| ) |  |

LTC6946 Write Single Field For SPI FIELDS in 1 or multiple address locations reads specific address/field location then writes to specific field can handle SPI fields in multiple addresses, if MSB bit is in the lower number address.

Returns
  void

Parameters

  cs | Chip Select Pin
  field_data | Value field value to be set to
  address | Register address for the LTC6946.
  MSB_loc | MSB bit location of field
  numbits | length of field (i.e. number of bits in field)

Definition at line 181 of file LTC6946.cpp.

## ◆ mul64()

void mul64 | ( | unsigned long | an[],
|  | unsigned long | ann[]
| ) |  |

64 bit multiply, an=an*ann

Returns
  void

Parameters

  an | 64 bit number, in 1x2 32bit array
  ann | 64 bit number, in 1x2 32bit array

Definition at line 977 of file LTC6946.cpp.

## ◆ prt()

void prt | ( | unsigned long | an[] | ) |

Prints HEX representation of 64 bit an.

Returns
  void

Parameters

  an | 64 bit number, in 1x2 32bit array

Definition at line 769 of file LTC6946.cpp.

## ◆ set_LTC6946_ALLREGS()

void set_LTC6946_ALLREGS | ( | uint8_t | cs,
|  | uint8_t | reg01,
|  | uint8_t | reg02,
|  | uint8_t | reg03,
|  | uint8_t | reg04,
|  | uint8_t | reg05,
|  | uint8_t | reg06,
|  | uint8_t | reg07,
|  | uint8_t | reg08,
|  | uint8_t | reg09,
|  | uint8_t | reg0A
| ) |  |

Writes values to ALL LTC6946 RW address.

Returns
  void

Parameters

  cs | Chip Select Pin
  reg01 | LTC6946 register 1
  reg02 | LTC6946 register 2
  reg03 | LTC6946 register 3
  reg04 | LTC6946 register 4
  reg05 | LTC6946 register 5
  reg06 | LTC6946 register 6
  reg07 | LTC6946 register 7
  reg08 | LTC6946 register 8
  reg09 | LTC6946 register 9
  reg0A | LTC6946 register 10

Definition at line 275 of file LTC6946.cpp.

## ◆ set_LTC6946_global_fref()

void set_LTC6946_global_fref | ( | unsigned long | fref_MHz,
|  | unsigned long | fref_Hz
| ) |  |

sets globals LTC6946_Fref_MHz and LTC6946_Fref_Hz

Returns
  void

Definition at line 472 of file LTC6946.cpp.

## ◆ set_LTC6946_global_frf()

void set_LTC6946_global_frf | ( | unsigned long | frf_MHz,
|  | unsigned long | frf_Hz
| ) |  |

sets globals LTC6946_Frf_MHz and LTC6946_Frf_Hz

Returns
  void

Definition at line 478 of file LTC6946.cpp.

## ◆ set_LTC6946_SPI_FIELD()

void set_LTC6946_SPI_FIELD | ( | uint8_t | cs,
|  | uint8_t | f,
|  | long | field_data
| ) |  |

Sets the LTC6946 SPI field value calls function LTC6946_read_field, which reads specific address/field location then writes to specific field can handle SPI fields in multiple addresses, if MSB bit is in the lower number address.

Returns
  void

Parameters

  cs | Chip Select Pin
  f | SPI field number
  field_data | Value field value to be set to

Definition at line 265 of file LTC6946.cpp.

## ◆ shl64()

void shl64 | ( | unsigned long | an[] | ) |

Single Bit shift left of equivalent 64 bit number (an[] = an[]<<1)

Returns
  void

Parameters

  an | an[] = an[]<<1

Definition at line 819 of file LTC6946.cpp.

## ◆ shl64by()

void shl64by | ( | unsigned long | an[],
|  | uint8_t | shiftnum
| ) |  |

Multi Bit shift left of equivalent 64 bit number (an[] = an[]<<shiftnum)

Returns
  void

Parameters

  an | an[] = an[]<<shiftnum
  shiftnum | number of bits to shift left

Definition at line 845 of file LTC6946.cpp.

## ◆ shr64()

void shr64 | ( | unsigned long | an[] | ) |

Single Bit shift right of equivalent 64 bit number (an[] = an[]<<1)

Returns
  void

Parameters

  an | an[] = an[]>>shiftnum

Definition at line 832 of file LTC6946.cpp.

## ◆ shr64by()

void shr64by | ( | unsigned long | an[],
|  | uint8_t | shiftnum
| ) |  |

Multi Bit shift right of equivalent 64 bit number (an[] = an[]>>shiftnum)

Returns
  void

Parameters

  an | an[] = an[]>>shiftnum
  shiftnum | number of bits to shift right

Definition at line 863 of file LTC6946.cpp.

## ◆ sub64()

void sub64 | ( | unsigned long | an[],
|  | unsigned long | ann[]
| ) |  |

64 bit Subtract ann from an (an[] = an[] - ann[])

Returns
  void

Parameters

  an | 64 bit number, in 1x2 32bit array
  ann | 64 bit number, in 1x2 32bit array

Definition at line 894 of file LTC6946.cpp.

## Variable Documentation

## ◆ LTC6946_Fref_Hz

unsigned long LTC6946_Fref_Hz = 0

Default Fref frequency - Hz portion (yyy,yyy); Fref = x,xxx, yyy,yyy.

Definition at line 87 of file LTC6946.cpp.

## ◆ LTC6946_Fref_MHz

unsigned long LTC6946_Fref_MHz = 100

Default Fref frequency - MHz portion (xxx); Fref = xxx, yyy,yyy.

Definition at line 86 of file LTC6946.cpp.

## ◆ LTC6946_Frf_Hz

unsigned long LTC6946_Frf_Hz = 0

Default Frf frequency - Hz portion (yyy,yyy); Frf = x,xxx, yyy,yyy.

Definition at line 89 of file LTC6946.cpp.

## ◆ LTC6946_Frf_MHz

unsigned long LTC6946_Frf_MHz = 900

Default Frf frequency - MHz portion (xxxx); Frf = x,xxx, yyy,yyy.

Definition at line 88 of file LTC6946.cpp.

## ◆ LTC6946_reg

uint8_t LTC6946_reg[LTC6946_NUM_REGADDR]

number of LTC6946 spi addresses

Definition at line 83 of file LTC6946.cpp.

## ◆ LTC6946_spi_map

uint8_t LTC6946_spi_map[(LTC6946_NUM_REGFIELD+1)][4]

LTC6946 spi map, stores MSB address location, MSB bit location, field length in bits, and R or RW capability.

Definition at line 84 of file LTC6946.cpp.

## ◆ zero64

unsigned long zero64[] = {0,0}

for 64bit math functions

Definition at line 91 of file LTC6946.cpp.